#include "atnd.h"

extern char *queue[QUEUE_ARRAY_SIZE];
extern int queue_begin, queue_end;
extern int ring_count;

BOOL allocating(RING_BUFFER *r, char *label, int a, int before, int p, int b, BOOL n) {
    BOOL allocated = TRUE;

    r->after = a;
    strcpy(r->file_name, label);
    r->number = n;
    r->point = p;
    r->ring_count = before + 1 + r->after;
    r->buffer_size = b;
    r->buffer = malloc(r->buffer_size);
    if(r->buffer == NULL) {
        fprintf(stderr, "malloc() error-4: %d bytes\n", r->buffer_size);
        allocated = FALSE;
    }

    r->combo = malloc(r->buffer_size);
    if(r->combo == NULL) {
        fprintf(stderr, "r->combo == NULL error: %d bytes\n",  r->buffer_size);
        allocated = FALSE;
    }

    return allocated;
}

BOOL standard_input_output(RING_BUFFER *r) {
    BOOL neighborhood = FALSE;
    BOOL written = FALSE;
    char *p;
    int count = 0;
    int line_number = 0;
    int sum = 0;
    LINE_NUMBER_FUNCTION line_begins = nonnumber;

    ring_count = r->ring_count;
    prepare_ring();

    if(r->number) {
        line_begins = line_begins_with_number;
    }

    if(r->after > 0) {
        for(;;) {
            p = fgets(r->buffer, r->buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            line_begins(r->buffer, r->combo);
            pop_front();
            push_back(r->buffer, r->buffer_size);

            if(neighborhood) {
                count += 1;
                if(count >= r->after) {
                    show_ring();
                    prepare_ring();
                    written = TRUE;
                    count = 0;
                    neighborhood = FALSE;
                }

            }

            line_number += 1;
            if(line_number == r->point) {
                neighborhood = TRUE;
                sum += 1;
            }

        }

    } else {
        for(;;) {
            p = fgets(r->buffer, r->buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            line_begins(r->buffer, r->combo);
            pop_front();
            push_back(r->buffer, r->buffer_size);

            line_number += 1;
            if(line_number == r->point) {
                neighborhood = TRUE;
                sum += 1;
                show_ring();
                prepare_ring();
                written = TRUE;
            }

        }

    }

    if(neighborhood) {
        if(written) {
            ;
        } else {
            show_ring();
            written = TRUE;
        }

    } else {
        neighborhood = (sum > 0) ? TRUE : FALSE;
    }

    return neighborhood;
}

